<!-- This example requires Tailwind CSS v2.0+ -->
<div class='fixed z-10 inset-0 overflow-y-auto' aria-labelledby='modal-title' role='dialog' aria-modal='true'>
  <div class='flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0'>

    <div class='fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity' aria-hidden='true'></div>

    <!-- This element is to trick the browser into centering the modal contents. -->
    <span class='hidden sm:inline-block sm:align-middle sm:h-screen' aria-hidden='true'>&#8203;</span>
    <div
      class='inline-block align-bottom bg-white rounded-lg px-4 pt-5 pb-4 text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full sm:p-6'>
      <form novalidate [formGroup]='syncForm' (submit)='syncHandler()'>
      <div>
        <div class='mx-auto flex items-center justify-center h-12 w-12 rounded-full'
             [ngClass]="{'bg-green-100': ref.data.isSynced, 'bg-rose-100': !ref.data.isSynced}"
        >
          <simulator-icon size='lg' class='h-6 w-6'
                          [ngClass]="{'text-green-600': ref.data.isSynced, 'text-rose-600': !ref.data.isSynced}"
                          [icon]="ref.data.isSynced ? 'check' : 'close'"></simulator-icon>
        </div>
        <div class='mt-3 sm:mt-5'>
          <h3 class='text-lg text-center leading-6 font-medium text-gray-900' id='modal-title'>
            <span *ngIf='!ref.data.isSynced else synced'>You'are not synced with DataDash App</span>
            <ng-template #synced>You're synced :)</ng-template>
          </h3>
          <div class='mt-2'>
            <p class='text-sm text-gray-500'>
              <span *ngIf='!ref.data.isSynced'>Please fill the informations below in order to sync with the app. Your Credentials will not be store in database.</span>
            </p>
            <simulator-alert class='lg:md:ml-8 mb-5 mt-5' *ngIf='error$ | async as error' [title]='error' logo='warning'
                             colorText='text-rose-500'
                             colorLogo='text-rose-500'></simulator-alert>
              <div class='text-left mt-6'>
                <label for='username' class='block text-sm font-medium text-gray-700'>Username used in DataDash</label>
                <div class='mt-1'>
                  <input type='text' name='username' id='username'
                         formControlName='username'
                         class='shadow-sm focus:ring-indigo-500 focus:border-indigo-500 block w-full sm:text-sm border-gray-300 rounded-md'
                         placeholder='you@example.com' aria-describedby='username-description'>
                </div>
              </div>
              <div class='mt-6'>
                <label for='password' class='block text-sm font-medium text-gray-700'>Password used in DataDash</label>
                <div class='mt-1'>
                  <input type='password' name='password' id='password'
                         formControlName='password'
                         class='shadow-sm focus:ring-indigo-500 focus:border-indigo-500 block w-full sm:text-sm border-gray-300 rounded-md'
                         placeholder='you@example.com' aria-describedby='password-description'>
                </div>
              </div>
              <div class='mt-6'>
                <div>
                  <label id='listbox-label' class='block text-sm font-medium text-gray-700'>
                    SuperNode used in DataDash
                  </label>
                  <div class='mt-1 relative'>
                    <button type='button'
                            (click)='toggleMenuHandler()'
                            class='cursor-pointer relative w-full bg-white border border-gray-300 rounded-md shadow-sm pl-3 pr-10 py-2 text-left cursor-default focus:outline-none focus:ring-1 focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm'
                            aria-haspopup='listbox' aria-expanded='true' aria-labelledby='listbox-label'>
                      <span class='flex items-center'>
                        <img
                          [src]='getLogoSupernode(supernode.value)'
                          alt='' class='flex-shrink-0 w-6 rounded-full'>
                        <span class='ml-3 block truncate'>
                          {{supernode.value}}
                        </span>
                      </span>
                      <span class='ml-3 absolute inset-y-0 right-0 flex items-center pr-2 pointer-events-none'>
                        <simulator-icon size='lg' class='h-5 w-5 text-gray-400' icon='selector'></simulator-icon>
                      </span>
                    </button>
                    <ul
                      [ngClass]="{'hidden': !toggleMenu, 'block': toggleMenu}"
                      class='z-10 mt-1 w-full bg-white shadow-lg max-h-56 rounded-md py-1 text-base ring-1 ring-black ring-opacity-5 overflow-auto focus:outline-none sm:text-sm'
                      tabindex='-1' role='listbox'>
                      <li class='text-gray-900 cursor-pointer select-none relative py-2 pl-3 pr-9'
                          (click)='updateSupernode(node.key)'
                          *ngFor='let node of supernodes | keyvalue' role='option'>
                        <div class='flex items-center'>
                          <img
                            [src]='node.value?.logo'
                            alt='' class='flex-shrink-0 w-6 rounded-full'>
                          <span class='font-normal ml-3 block truncate'>
                            <b>{{node.key}}</b> {{node.value.region}}
                          </span>
                        </div>
                        <span class='text-indigo-600 absolute inset-y-0 right-0 flex items-center pr-4'
                              *ngIf='supernode.value === node.key'>
                          <simulator-icon size='lg' class='h-5 w-5' icon='check'></simulator-icon>
                        </span>
                      </li>
                    </ul>
                  </div>
                </div>
              </div>
          </div>
        </div>
      </div>
      <div class='mt-5 sm:mt-6 sm:grid sm:grid-cols-2 sm:gap-3 sm:grid-flow-row-dense'>
        <button type='submit'
                class='w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-indigo-600 text-base font-medium text-white hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:col-start-2 sm:text-sm'>
          Synchronize
        </button>
        <button type='button'
                (click)='dialog.closeAll()'
                class='mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:col-start-1 sm:text-sm'>
          Cancel
        </button>
      </div>
      </form>
    </div>
  </div>
</div>
